/* bcl.c        build command list for ccalc.c */



#include<stdio.h>

#include<stdlib.h>

#include<string.h>



/* bver and bdat are written into chelp2.h for inclusion in ccalc.c */

#define bver "v0.02b"

#define bdat "07/21/2003"



#define n_cmd 100

#define syn_len 600

#define name_len 8

#define help_len 60



struct command

{  char name[name_len];

   char shortcut[name_len];

   char syntax[syn_len];

   char help[help_len];

} cmd[n_cmd];



void sorta();

void buildc();

void pc();

void pd();

void ps();



int l;          /* number of commands */

FILE *fi;

int ninf=3;

char inf[3][10]={"cstack.h","cfuncs.h","mofunc.h"};



int main()

{  int x, y, z, ff, f, loo=0;

   char buf[2048], buf2[2048], *str;

   FILE *file, *fy;



   printf("\nbcl, Scott Olson, %s %s\n\n", bver, bdat);

   fy=fopen("bcl.in","w");

   for(ff=0, l=0; ff<ninf; ff++)

   {  file=fopen(inf[ff], "r");

      printf("Reading %s...\n", inf[ff]);

      fprintf(fy, "Reading %s...\n", inf[ff]);

      while(fgets(buf2, 1000, file)!=NULL)

      {  buf2[3]=0; f=0;

         /* look for marker, strip off right whitespace and end of comment */

         if(strcmp(buf2,"/*?")==0)

         {  strcpy(buf, buf2+4);

            for(x=strlen(buf)-1; x>=0 && f!=3; x--)

            {  if(buf[x]==' ' || buf[x]<=13) buf[x]=0;

               else

               {  if(buf[x]=='/' && f==0) f=1;

                  else if(buf[x]=='*' && f==1) f=2;

                       else { f=3; buf[x+1]=0; }

               }

            }

         }

         if(f==3)

         {  if(strlen(buf)>help_len)

            {  printf("help line too long in function %s (%d). recompile bcl", inf[ff], l);

               fclose(file); return 1;

            }

            strcpy(cmd[l].help, buf);

            if((fgets(buf2, 1000, file)==NULL) || buf2[2]!='|')

            {  printf("command line error in file %s\nline:\n%s", 

                  inf[ff], buf2);

               fclose(file); return 1;

            }

            strcpy(buf, buf2+4);

            for(x=0; buf[x]!=0 && buf[x]!='|'; x++) ;

            if(buf[x]==0)

            {  printf("| not found in file %s command line\n%s\n", 

                  inf[ff], buf);

               fclose(file); return 1;

            }

	      buf[x]=0; strcpy(cmd[l].name, buf); strcpy(buf2, buf+x+1);



            /* strip off right whitespace and end of comment */

            for(f=0, x=strlen(buf2)-1; x>=0 && f!=3; x--)

            {  if(buf2[x]==' ' || buf2[x]<=13) buf2[x]=0;

               else

               {  if(buf2[x]=='/' && f==0) f=1;

                  else if(buf2[x]=='*' && f==1) f=2;

                       else { f=3; buf2[x+1]=0; }

               }

            }

            x=strlen(buf2)-1; cmd[l].syntax[0]=0;

            while(buf2[x]=='\\')

            {  buf2[x]=0; strcat(cmd[l].syntax, buf2);

               strcat(cmd[l].syntax, "\n");

               if(strlen(cmd[l].syntax)>syn_len)

               {  printf("\007\nSyntax too long [syn_len], recompile bcl.c\n");

                  return 1;

               }

               if(fgets(buf2, 1000, file)==NULL)

               {  printf("early EOF in %s\n", inf[ff]); return 1;

               } 

               /* rstrip white */

               for(x=strlen(buf2)-1; x>0; x--)

                  if(buf2[x]<=13) buf2[x]=0; x=strlen(buf2)-1;

            }               

            if(buf2[x]!='|' || f!=3)  /* need | for mark end of syntax input */

            {  printf("| not found in file %s command line\n%s\n", 

                  inf[ff],buf2);

               fclose(file); return 1;

            }

            buf2[x]=0; strcat(cmd[l].syntax, buf2);

            if(strlen(cmd[l].syntax)>syn_len)

            {  printf("\007\n Syntax too long [syn_len], recompile bcl.c\n");

               return 1;

            }

	      fprintf(fy,"%2d %6s [%s] [%s]\n",

                 l,cmd[l].name, cmd[l].help, cmd[l].syntax);

              cmd[l].shortcut[0]=0;

            if(strlen(cmd[l].syntax)>loo) loo=strlen(cmd[l].syntax);

            l++;

            if(l>=n_cmd)

            { printf("\007\n Too many commands [n_cmd], recompile bcl.c\n");

              return 1;

            }

         }

      }

      fclose(file);

   }

   fclose(fy);

   printf("\nStuff written to bcl.in\n\n");

   printf("%d functions read.\tLongest syntax: %d\n\n", l, loo);



   printf("Sorting... ");

   sorta(); 



   /* make shortcuts */

   strcpy(cmd[0].shortcut, cmd[0].name); cmd[0].shortcut[1]=0;

   for(x=1; x<l; x++)

   {  strcpy(buf, cmd[x].name); strcpy(cmd[x].shortcut, buf);



      /* don't zap numbers  (c<65) */

      for(z=0, y=0; buf[y]!=0; y++) if(buf[y]<65 && buf[y]!=0) z=y;

      if(buf[z]!=0 && buf[z+1]!=0 && buf[z]<65) z++;

      

      for(y=z; buf[y]!=0 && buf[y]==cmd[x-1].shortcut[y]; y++) ;

      for(z=y+1; z<name_len; z++)

         cmd[x].shortcut[z]=0;

   }



   for(x=0; x<l; x++)  /* up it */

   {  str=&cmd[x].shortcut[0];

      for(z=0; *(str+z)!=0; z++)

         if(*(str+z)>96 && *(str+z)<123) *(str+z)=*(str+z)-(char)32;

   }



   file=fopen("bcl.out", "w");

   for(x=0; x<l; x++)

   {  fprintf(file, "%3d: %5s (%s)     \t%s\n",

         x,cmd[x].name,cmd[x].shortcut,cmd[x].help);

   }

   fprintf(file,"\n\n");

   fclose(file);



   /* create chelp2.h which contains help2() a list of all functions (?f) */

   file=fopen("chelp2.h", "w");

   fprintf(file,"#define bver \042%s\042\n", bver);

   fprintf(file,"#define bdat \042%s\042\n\n", bdat);

   fprintf(file, "void help2();\n\nvoid help2(void)\n{ ");

   fprintf(file, "char buf[100];\n  printf(\042\\n");

   fprintf(file, "  Function Shorthand    Description\\n\042);\n\n");

   for(x=0, y=1; x<l; x++, y++)

   {  fprintf(file,"printf(\042%3d: %5s (%s)     \t%s\\n\042);\n",

         x+1,cmd[x].name,cmd[x].shortcut,cmd[x].help);

      if(y>=30)

      {  fprintf(file,"printf(\042\\nHit Return for more.\042);\n");

         fprintf(file,"fgets(buf,20,stdin);\n  printf(\042\\n");

         fprintf(file, "  Function Shorthand    Description\\n\042);\n\n");

         y=0;

      }

   }

   fprintf(file,"}\n");

   fclose(file);



   printf("%d functions sorted and shortened\n\nBuilding... ", l);



   buildc();

   printf("bcl.h built.\n\n");

   return 0;

}



void sorta()

{  int x,y,z;

   char b[2048];



   for(y=0; y<l-1; y++)

   {  for(x=0; x<l-1; x++)

      {  z=strcmp(cmd[x].name,cmd[x+1].name);

	 if(z>0)

	 {  strcpy(b,cmd[x+1].name); strcpy(cmd[x+1].name,cmd[x].name); 

               strcpy(cmd[x].name,b);

	    strcpy(b,cmd[x+1].syntax); strcpy(cmd[x+1].syntax,cmd[x].syntax);

               strcpy(cmd[x].syntax,b);

	    strcpy(b,cmd[x+1].help); strcpy(cmd[x+1].help,cmd[x].help);

               strcpy(cmd[x].help,b);

	 }

      }

   }

}



#include"build.h"

