/* ccalc.c
   Version  Date        Comment
   v0.001   02/04/2002  rewrite of ccalc.c
   for later version descriptions, see readme.ver

0        1         2         3         4         5         6         7         8
12345678901234567890123456789012345678901234567890123456789012345678901234567890
*/

#define ver "Complex Calculator, v0.02f, 8/14/2003"

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>

void upit();
void float2radix();

#include"cfuncs.h"
#include"cstack.h"
#include"chelp.h"
#include"chelp2.h"

int main( argc, argv )
short  argc;
char   *argv[];
{  int x, y, s_size=4, m_size=50;
   struct complex z, *xp, *yp;
   struct stack *s1, *s1u, *sp;
   struct memory *m1, *mp;
   char erm[50];     /* error messages */
   /* mag(mode) is the radix, sgn(mode) is %f or %e print format */
   int mode=10;
   int fix=4, cl=0, init=0, not_done=1, err; /* flags */
   double a, b, rd;

   char   in[256], in_m[1024], in2[256], *p, in0[256];
   char   buf[1024], buf2[256], bufin[1024];        /*buffers*/
   FILE   *fyle;
   int    pc=1; /* help level */

   /* Allocate a stack and memory, set degree mode */
   if((s1=s_alloc(s_size, erm))==NULL) printf(" %s", erm);
   if((s1u=s_alloc(s_size, erm))==NULL) printf(" %s", erm);
   if((m1=m_alloc(m_size, erm))==NULL) printf(" %s", erm);
   s_clear(s1); s_clear(s1u); m_clear(m1);
   rd=180.0/acos(-1); in_m[0]=0;
   xp=&s1->d[0]; yp=&s1->d[1]; sp=s1; mp=m1;
   
   if(argc>1)
   {  for(x=1, in_m[0]=0, init=1; x<argc; x++)
      {  strcat(in_m, argv[x]); strcat(in_m, " ");
      }
      if(argv[argc-1][0]=='q' || argv[argc-1][0]=='Q') cl=1;  
   }
   if(!cl)
   {  printf("\n%s\n\n", ver);
      printf("Type '?' or 'h' for help.\n\n");
      if(argc==1) { s_print(s1, mode, fix, rd); }
   }
  
   do
   {  if(init && !cl) printf("=>%s\n", in_m);
      if(in_m[0]==0)    /* test for continuation of multiple command */
      {  printf("=>"); fgets(in_m, 1024, stdin); in_m[strlen(in_m)-1]=0;
      }
      init=0;
   
Cmd:  /* multiple commands are seperated by spaces, strip off 1st command */
      err=0; 
      for(x=0; in_m[x]!=32 && in_m[x]!=0; x++) in[x]=in_m[x];
      in[x]=0;
      if(in_m[x]==0)
         in_m[0]=0; /* last command */
      else 
      {  for(y=0; in_m[y+x+1]>0; y++) in_m[y]=in_m[y+x+1];
         in_m[y]=0;
      } 
      strcpy(in0, in); upit(in);  /* convert to upper */
  
      if(!cl && (pc>0)) printf(" {%s}", in0);                  
  
Cmd1: /* Save states in case of an undo */
      if (in[0]!='U')
      {  for(x=0; x<s1->len; x++) s1u->d[x]=s1->d[x];
         /* was err=2 here ??? */  
      }

      erm[0]=0; err=2;
      /* These are done with brute force so not to confuse with numeric entry */
      if (strcmp(in, "1/X")==0)  err=c_inv(xp, erm);
      if (strcmp(in, "+")==0)    { err=c_add(yp,*xp); s_pop(sp); }
      if (strcmp(in, "-")==0)    { err=c_sub(yp,*xp); s_pop(sp); }
      if (strcmp(in, "10^X")==0) err=c_tenx(xp);
      if (strcmp(in, "10^")==0)  err=c_tenx(xp);
      if (strcmp(in, "^")==0)    { err=c_YpX(yp,*xp); s_pop(sp); }
      if (in[0]==0)              strcpy(in, "PUSH");

      if(err==2)
      {  /* this is the command switch structure created with bcl.c */
#include"bcl.h"
      }

      if(err==2) /* no command, try for a number */
      {  if((err=str2cx(in0,&z,rd))==0)
         { s_push(s1); s1->d[0]=z;
           if(in0[0]!=0) { strcpy(in, in0); upit(in); goto Cmd1; }
         }
      }
      if (err>0 && pc>=0) printf("\007 %s <=Error", erm);
      
      if (not_done && in_m[0]==0 && pc>=0)
      { if(pc>=0) printf("\n");
        if(pc>0) printf("\n");
        if((err=s_print(s1, mode, fix, rd, erm))!=0)
           printf("%s error.\007", erm);
      }
   }  while(not_done);

   if(cl)
   {  if (mode>0) printf("%f\n", s1->d[0].a);
      else        printf("%e\n", s1->d[0].a);
   }
   else printf("\n");
   return err;
}

void upit(str)
char *str;
{  int x;
   for(x=0; *(str+x)!=0; x++)
      if(*(str+x)>96 && *(str+x)<123) *(str+x)=*(str+x)-(char)32;
}

void float2radix(p, h, radix)
char  *p;
double h;
int    radix;
{  int x, y;
   char buf[1000];
   double h1;

   h=h+0.5; /* round up */
   for(x=0; h>0.0 && x<100; x++) /* 100 for safety? */
   {  h1=h-floor(h/(double)radix)*(double)radix;
      if(h1<10) y=(int)h1+48; else y=(int)h1+55;
      buf[x]=y;
      h=floor(h/(double)radix);
   }
   buf[x]=0; *p=0;
   switch(radix)
   {  case 16: strcpy(p, "0x"); p=p+2; break;
      case  8: strcpy(p, "0o"); p=p+2; break;
      case  2: strcpy(p, "0b"); p=p+2; break;
      default: sprintf(p, "(base%d)  ", radix); p=p+8; if(radix>9) p++;
   }
   for(x--;x>=0;x--, p++) *p=buf[x]; *p=0;
}
