/* mofunc.h         more functions. variables allocated in ccalc.c */

/* duplicate these defines in cfuncs.h */
#define mver "v0.02f"
#define mdat "07/09/2022"

Contents:
?n, <, [, base, bin, ca, c2z, d, d2v, dbv, dec, fixN, frN, help, hex, l2z, m<, m>,
oct, pi, r, res, rmN, s2z, sci, smN, v2d, v2w, ver, w2v, z2c, z2l, z2s

/*? Print help*/
/*| ?|err=0;help();|
/*? Program quiet unless asked to speak*/
/*| ?-|err=0;pc=-1;|
/*? Verbose help off
/*| ?0|err=0;pc=0;|
/*? Verbose help level 1 (shows parsing)
/*| ?1|err=0;pc=1;|
/*? Verbose help level 2 (command descriptions)
/*| ?2|err=0;pc=2;|
/*? Print function list
/*| ?F|err=0;help2();|

/*? Enter commands from a file, <filename
/*| <|err=0;\
/* the concatonate don't work. is it just MS? */\
if( (fyle=fopen(in0+1, "r"))!=NULL)\
{  buf[0]=0; x=0; if(pc>=0) printf("\n\n");\
   while(fgets(bufin, 1023, fyle)!=NULL)\
   {  if(pc>=0) { x++; printf("file line%2d:%s", x, bufin); }\
      for(y=0; bufin[y]!=0; y++) if(bufin[y]=='#') bufin[y]=0;\
      if(bufin[0]!=0)\
      {  bufin[strlen(bufin)-1]=' '; strcat(buf,bufin);\
      }\
   }\
   fclose(fyle);\
   if(pc>=0) printf("\n\ncat: %s\n\n", buf);\
   if(buf[0]!=0)\
   {  strcat(buf, in_m); strcpy(in_m, buf);\
   }\
 }\
 else { strcpy(erm,"File open error."); err=1; }|

/*? Memory shortname, [mem_name
/*| [|err=0;\
/* look for end of name, non-alphanumeric */\
for(x=0, p=&in[0]+1; *p>47; p++, x++) buf[x]=*p;\
buf[x]=0;\
strcpy(buf2, "RM"); strcat(buf2, buf); x=m_find(m1, buf2);\
if(x==-1)\
{  if(pc>=0) printf("\007Invalid memory location %s\n", buf);\
   in[0]=0;\
}\
else\
{  s_push(sp); *xp=mp->e[x].d; \
   strcpy(in, p); if(in[0]!=0) goto Cmd1;\
}|

/*? Base for numeric display
/*| base|for(x=0; x<4 && in[x]>64; x++) ; a=atof(in+x);\
if(a<2 || a>36) { strcpy(erm, " Valid base range 2-36 "); err=1; }\
else { if(mode>0) mode=a; else mode=-a; err=0;}|

/*? Binary format
/*| bin|if(mode>0) mode=2; else mode=-2;\
err=0;|

/*? Clear all, clears stack and memory
/*| ca|s_clear(sp); m_clear(mp); err=0;|

/*? Capacitance to impedance (memory w)
/*| c2z|if((x=m_find(mp,"RMW"))==-1)\
{  strcpy(erm," No w specified."); err=1; }\
else\
   err=c_c2z(xp,mp->e[x].d,erm);|

/*? Degree mode
/*| d|if(pc>=0)printf(" Degree mode."); rd=180.0/acos(-1.0); err=0;|

/*? dbm to voltage (memory R or default 50 ohms)
/*| d2v|z=cx(50.0,0.0);\
if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;\
err=c_d2v(xp,z,erm);|

/*? y=20*log10(y/x), pop stack
/*| dbv|err=c_db(yp,*xp,erm);c_mult(yp,2.0);s_pop(sp);|

/*? Decimal format
/*| dec|if(mode>0) mode=10; else mode=-10;\
err=0;|

/*? Fix print precision, fixN (N=0-15)
/*| fix|a=atof(in+3);\
if(a<0 || a>15) { strcpy(erm, " Fix range 0-15 "); err=1; }\
else { fix=a; err=0; }\
break;|

/*? frN: set frequency, w=2pi*N, saved in memory w
/*| fr|if(in[2]==0) { strcpy(erm,"Zero frequency. "); err=1; }\
else { x=m_find(mp,"SMW");\
mp->e[x].d = cx(atofM(in0+2)*2*acos(-1), 0.0); err=0;\
}|

/*? Help
/*| help|help();err=0;|

/*? Hexadecimal format
/*| hex|if(mode>0) mode=16; else mode=-16;\
err=0;|

/*? Inductance to impedance (memory w)*/
/*| l2z|if((x=m_find(mp,"RMW"))==-1)\
{  strcpy(erm,"No w specified."); err=1; }\
else\
   err=c_l2z(xp,mp->e[x].d,erm);|

/*? Write memory to a file, m>filename
/*| m>|if( (fyle=fopen(in0+2, "w"))!=NULL)\
{  for(x=0; x<mp->len; x++)\
      fprintf(fyle, "%s %e %e\n",\
         mp->e[x].name, mp->e[x].d.a, mp->e[x].d.b);\
   err=0;\
}\
else { strcpy(erm,"File open error."); err=1; }\
fclose(fyle);|

/*? Load memory from a file, m<filename
/*| m<|err=0;\
if( (fyle=fopen(in0+2, "r"))!=NULL)\
{  while((y=fscanf(fyle,"%s %lf %lf\n", buf, &a, &b))!=EOF)\
   {  if(buf[0]!=0 && y>1)\
      {  strcpy(buf2, "SM"); strcat(buf2, buf);\
         x=m_find(m1,buf2);\
         mp->e[x].d.a=a; if(y>2) mp->e[x].d.b=b; err=0;\
      }\
      else { sprintf(erm,"\nFile syntax error at: %s", buf); err=1;}\
   }\
   fclose(fyle);\
}\
else { strcpy(erm,"File open error."); err=1; }|

/*? Octal format
/*| oct|if(mode>0) mode=8; else mode=-8;\
err=0;|

/*? Pi, push, enter pi into x*/
/*| pi|s_push(sp); *xp=cx(acos(-1.0), 0.0); err=0;\
if(in[2]!=0 && in[2]!=' ')\
   { strcpy(in2, in+2); strcpy(in, in2); goto Cmd1; }|

/*? Quit
/*| q|not_done=0; err=0;|

/*? Radian mode
/*| r|if(pc>=0)printf(" Radian mode."); rd=1.0; err=0;|

/*? Resonant impedance (memory w)
/*| res|x=m_find(m1, "RMW");\
if(x==-1) {strcpy(erm,"w not specified. "); err=1; break; }\
err=c_res(xp,mp->e[x].d,erm);|

/*? Recall memory, rmN where N is an alphanumeric name
/*| rm|x=m_find(mp,in);\
if(x==-1)\
{  sprintf(erm," %s not found.", in+2); err=1;\
   if(pc>0)\
   {  printf("\nValid names:\t");\
      for(x=0; x<mp->len; x++) printf("%s\t", mp->e[x].name);\
      printf("\n");\
   }\
}\
else\
{  s_push(sp); *xp=mp->e[x].d;  err=0;}\
|

/*? s11 to impedance (memory Z0 or default 50 ohms)
/*| s2z|z=cx(50.0,0.0);\
if( (x=m_find(mp,"RMZ0"))!=-1) z=mp->e[x].d;\
err=c_s2z(xp,z,erm);|

/*? save to memory, smN where N is an alphanumeric name
/*| sm|x=m_find(mp,in);\
if(x==-1) { strcpy(erm,"Memory full\n"); err=1; }\
else { mp->e[x].d=*xp; err=0; }|

/*? Print format, toggles between float and scientific format
/*| sci|mode=-mode; err=0;|

/*? Undo, recall last stack (doesn't restore memory)
/*| u|for(x=0; x<sp->len; x++) sp->d[x]=s1u->d[x]; err=0;|

/*? Voltage to dbm (memory R or default 50 ohms)
/*| v2d|z=cx(50.0,0.0);\
if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;\
err=c_v2d(xp,z,erm);|

/*? Voltage to watts (memory R or default 50 ohms)
/*| v2w|z=cx(50.0,0.0);\
if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;\
err=c_v2w(xp,z,erm);|

/*? Print program version
/*| ver|{printf("\n\n%s\n\n", ver);\
printf("bcl     %s  %s\n", bver, bdat);\
printf("cfuncs  %s  %s\n", fver, fdat);\
printf("cstack  %s  %s\n", sver, sdat);\
printf("chelp   %s  %s\n", hver, hdat);\
printf("mofunc  %s  %s", mver, mdat); err=0;}|

/*? Watts to voltage (memory R or default 50 ohms)
/*| w2v|z=cx(50.0,0.0);\
if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;\
err=c_w2v(xp,z,erm);|

/*? Impedance to capacitance (memory w)
/*| z2c|x=m_find(m1, "RMW");\
if(x==-1) { strcpy(erm,"w not specified. "); err=1; break; }\
err=c_z2c(xp,mp->e[x].d,erm);|

/*? Impedance to inductance (memory w)
/*| z2l|x=m_find(m1, "RMW");\
if(x==-1) { strcpy(erm,"w not specified."); err=1; break; }\
err=c_z2l(xp,mp->e[x].d,erm);|

/*? Impedance to s11 (memory Z0 or default 50 ohms)
/*| z2s|z=cx(50.0,0.0);\
if( (x=m_find(mp,"RMZ0"))!=-1) z=mp->e[x].d;\
err=c_z2s(xp,z,erm);|
